1 # Ocean Interpreter test code
3 Regular testing is, of course, important for developing any software.
4 The Ocean interpreted is no exception. This document allows easy
7 - a collection of test program
8 - the expected output of these programs when run with various arguments
9 - some "Makefile" code to tie it all together.
11 Three different sorts of tests are run. As soon as any fail, the whole
14 1/ Each program is run and the output is compared against the expected
16 2/ Each program is then run under valgrind, and an error is reported
17 if valgrind detects an error, or if it reports and lost or unfreed
19 3/ Each program is parsed and printed, then the result is parsed and printed.
20 The two results must match.
21 4/ Each program is run with a version of `oceani` with test-coverage
22 recording enabled. Once all programs have successfully run and
23 all the coverage data is available, we check that all lines have
24 been tested at least once. A few exceptions are allowed such as
25 lines that call `abort()`. If any non-exceptional lines have not
26 been run, this final test fails.
27 Until the tests suite is (more) completed, we only throw and error
28 if fewer than 75% of the lines have been tested.
30 Each test has a name, which used to identify the section in this file, and optionally some
31 arguments separated from the name by commas. For each test, there is a section named
32 "output:" followed by the name-and-arguments.
34 ###### File: oceani-tests.mk
39 tests:: oceani_test_suite
40 oceani_test_suite: oceani coverage_oceani
41 @echo -n Checking grammar ...
42 @./parsergen --report --LALR --tag Parser oceani.mdc | grep " - no conflicts" > /dev/null || \
43 { echo "Grammar contains conflicts, please review" ; exit 1; }
45 @rm -rf coverage; mkdir -p coverage
47 @for T in $(oceani_tests); do \
48 echo -n "Test $$T.. "; \
49 i="$$IFS"; IFS=,; set $$T; IFS="$$i"; t=$$1; shift; \
50 ./md2c oceani-tests.mdc "output: $$T" | grep -v '^#' > .tmp.want; \
51 ./oceani --section "test: $$t" oceani-tests.mdc $${1+"$$@"} > .tmp.have; \
52 if ! cmp -s .tmp.want .tmp.have; then \
53 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
54 echo -n "printing.. "; \
55 echo '``````' > .tmp.code1; echo '``````' > .tmp.code2 ;\
56 ./oceani --noexec --print --section "test: $$t" oceani-tests.mdc >> .tmp.code1; \
57 ./oceani --noexec --print .tmp.code1 >> .tmp.code2 || exit 1;\
58 if ! cmp -s .tmp.code1 .tmp.code2; then \
59 echo " Failed"; diff -u .tmp.code1 .tmp.code2; exit 1 ; fi ; \
60 echo -n "extra-newlines.. "; \
62 ' .tmp.code1 > .tmp.code1a; \
63 echo '``````' > .tmp.code2a ;\
64 ./oceani --noexec --print .tmp.code1a >> .tmp.code2a || exit 1;\
65 if ! cmp -s .tmp.code1 .tmp.code2a; then \
66 echo " Failed"; diff -u .tmp.code1 .tmp.code2a; exit 1; fi ; \
67 echo -n "exec-after-print.. "; \
68 ./oceani .tmp.code1 $${1+"$$@"} > .tmp.have ; \
69 if ! cmp -s .tmp.want .tmp.have; then \
70 echo " FAILED"; diff -u .tmp.want .tmp.have; exit 1;fi; \
72 ./coverage_oceani --print --section "test: $$t" oceani-tests.mdc $${1+"$$@"} > /dev/null ; \
73 ./coverage_oceani -tpbn --section "test: $$t" oceani-tests.mdc > /dev/null 2>&1; \
78 @for i in coverage/#*.gcda; do mv $$i coverage/$${i##*#}; done
79 @gcov -o coverage oceani.mdc > /dev/null 2> /dev/null
80 @mv *.gcov coverage ; [ -f .gcov ] && mv .gcov coverage || true
81 @ awk '/NOTEST/ { next } /^ *[1-9]/ {ran+=1} /^ *###/ {skip+=1} \
82 END {printf "coverage: %6.2f%%\n", ran * 100 / (ran + skip); \
83 if (ran < (ran + skip) *0.94) exit(1) }' \
84 coverage/oceani.mdc.gcov
87 @for T in $(oceani_tests); do \
88 echo -n "Valgrind $$T.. "; \
89 i="$$IFS"; IFS=,; set $$T; IFS="$$i"; t=$$1; shift; \
90 if ! valgrind --error-exitcode=1 --log-file=.tmp.valg ./oceani --section "test: $$t" oceani-tests.mdc $${1+"$$@"} \
91 > /dev/null 2>&1 ; then \
92 echo "FAILED"; cat .tmp.valg; exit 1; fi ; \
93 if grep 'LEAK SUMMARY' .tmp.valg > /dev/null; then \
94 echo "valgrind found LEAKS"; cat .tmp.valg ; exit 1 ; fi; \
95 if grep 'in use at exit [1-9]' .tmp.valg > /dev/null; then \
96 echo "valgrind found memory in use at exit"; cat .tmp.valg ; exit 1 ; fi; \
100 coverage_oceani: oceani.c
101 $(CC) $(CFLAGS) --coverage -fprofile-dir=coverage -o coverage_oceani oceani.c $(LDLIBS)
103 ## Values and variables
105 The first test stores values in variables and performs various
106 calculations on them.
109 oceani_tests += "valvar"
114 a := 23; b:=12 ; b1 := -b
115 print a, b, a+b, a-b, a*b, a/b, a%b
116 print a<b, a<=b, a>b, a>=b, a<a, a==b, a==a
117 print +a, +b, +b1, -a, -b, -b1
118 x := True; y := False
119 print x and y, x or y, x and x, y or y, x and not x, x < y
121 c ::= "This is a string"
122 d ::= " field theory"
125 aconst :: string = "unchanging"
134 ###### output: valvar
136 23 12 35 11 276 1.91667 11
137 False False True True False False True
139 False True True False False False
140 This is a string field theory This is a string field theory
143 Next we change the value of variables
146 oceani_tests += "setvar"
153 a = (a + a) * (a + a)
157 ###### output: setvar
163 oceani_tests += "consts"
168 four ::= 2 + 2 ; five ::= 10/2
169 const pie ::= "I like Pie";
170 cake ::= "The cake is"
174 print "Hello World, what lovely oceans you have!"
175 print "are there", five, "?"
176 print pi, pie, "but", cake
178 ###### output: consts
179 Hello World, what lovely oceans you have!
181 3.14159 I like Pie but The cake is a lie
183 Test merging of variables from multiple cases
186 oceani_tests += varmerge
188 ###### test: varmerge
191 for i:=0; then i=i+1; while i < 5:
201 ###### output: varmerge
202 zero , one , two , three , many ,
204 ## Conditions and Loops
206 Now we need to test if/else and some different loops
209 oceani_tests += cond_loop
211 ###### test: cond_loop
219 for b:=1; then b=b+b; while b < 100:
222 // Newtons method for square root of 2
228 current := guess * guess
229 use +(current - target) > 0.000000001
231 guess = (guess + (target / guess) ) / 2
234 print "error is ", target - guess * guess
236 for j:=0; then j = j+3 ; while j < 10:
237 if j != 0 and then 20 / j > 3:
238 print "20 /", j," =", 20 / j
240 print "I won't calculate 20 /", j
241 pi ::= 3.1415926535897
242 if 355/113 == pi or else +(pi - 355/113) < 0.001:
244 print "lower" if 355/113 < pi else "higher"
246 if pi > 3 then print "pi exceeds three"; else print "need more pie"
247 if (pi < 3) { print "not enough pi" } else { print "pi sufficient" }
248 for { i := 0; sum := 0 }
254 print "sum 1..10 is", sum
256 ###### output: cond_loop
263 error is -4.51095e-12
264 I won't calculate 20 / 0
267 I won't calculate 20 / 9
276 The demonstration code presented in the interpreted is suitable for the test suite.
277 Here I break it into two parts, keeping the array code separate.
280 oceani_tests += "sayhello,55,33,hello,True"
281 oceani_tests += "sayhello,12,60,there,False"
283 ###### test: sayhello
285 program A B astr bbool:
286 print "Hello World, what lovely oceans you have!"
287 /* When a variable is defined in both branches of an 'if',
288 * and used afterwards, the variables are merged.
294 print "Is", A, "bigger than", B,"? ", bigger
295 /* If a variable is not used after the 'if', no
296 * merge happens, so types can be different
299 double:string = "yes"
300 print A, "is more than twice", B, "?", double
303 print "double", B, "is", double
314 print "GCD of", A, "and", B,"is", a
316 print a, "is not positive, cannot calculate GCD"
318 print b, "is not positive, cannot calculate GCD"
323 print "Fibonacci:", f1,f2,
333 print astr ++ " was the str"
335 print "I found the str over " ++ astr
337 /* Binary search... */
354 print "Yay, I found", target
356 print "Closest I found was", mid
358 ###### output: sayhello,55,33,hello,True
359 Hello World, what lovely oceans you have!
360 Is 55 bigger than 33 ? yes
362 GCD of 55 and 33 is 11
363 Fibonacci: 1 1 2 3 5 8 13 21 34 55 89 144
365 Closest I found was 77.3438
367 ###### output: sayhello,12,60,there,False
368 Hello World, what lovely oceans you have!
369 Is 12 bigger than 60 ? no
371 GCD of 12 and 60 is 12
372 Fibonacci: 1 1 2 3 5 8 13 21 34 55 89 144
373 I found the str over there
374 Closest I found was 77.3438
377 oceani_tests += "insert_sort"
378 ###### test: insert_sort
383 for i:=1; then i = i + 1; while i < size:
384 n := list[i-1] * list[i-1]
385 list[i] = (n / 100) % 10000
388 for i:=0; then i = i + 1; while i < size:
389 print "list[",i,"]=",list[i]
391 for i := 1; then i=i+1; while i < size:
392 for j:=i-1; then j=j-1; while j >= 0:
393 if list[j] > list[j+1]:
398 for i:=0; then i = i + 1; while i < size:
399 print "list[",i,"]=",list[i]
401 ###### output: insert_sort
517 We already have some array tests, but this is where we put other
518 ad-hoc things array related.
521 oceani_tests += arrays
529 bools[3] = strings[1] == "Hello"
530 bools[1] = strings[2] <= "there"
532 for i:=0; then i=i+1; while i<5:
536 ###### output: arrays
537 False True False False False
541 Time to test if structure declarations and accesses work correctly.
544 oceani_tests += structs
553 struct baz { a:number; b:Boolean; }
558 for i:=0; then i=i+1; while i < 4:
566 info[i].size[0] = i*i
567 info[i].active = nm == "jane"
569 for i:=0; then i=i+1; while i < 4:
570 print info[i].name, info[i].active, info[i].size[0]
572 ###### output: structs
579 ## Test code with syntax errors
581 Syntax errors aren't handled well yet - the result is almost always a
582 single message about the first error. So this section will be fairly
583 thin until we add proper parsing recovery in the face of common errors.
585 A special case of syntax errors is token errors, when a token is only
586 accepted because the parser doesn't know quite enough to reject it.
587 There are handled better as they are quite local, so a single test
588 program can trigger most of the possible errors.
590 To handle erronous code, we need a different set of tests, as we need to
591 capture `stderr`. The same test code will be used for type errors too.
592 As error messages contain the line number, and we don't want changes to
593 this file to change the reported numbers, we copy the code into a
594 separate file first, then run from there.
597 @for t in $(oceani_failing_tests); do \
598 echo -n "Test $$t ... "; \
599 ./md2c oceani-tests.mdc "output: $$t" | grep -v '^#' > .tmp.want; \
600 echo '``````' > .tmp.code; \
601 ./md2c oceani-tests.mdc "test: $$t" | grep -v '^#' >> .tmp.code; \
602 ./oceani .tmp.code > .tmp.have 2>&1; \
603 if ! cmp -s .tmp.want .tmp.have; then \
604 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
606 ./coverage_oceani --section "test: $$t" oceani-tests.mdc > /dev/null 2>&1 ;\
610 oceani_failing_tests := syn1
611 oceani_failing_tests += tokerr
616 if then else while do
619 .tmp.code:3:11: Syntax error in statement: then
623 a := 1i // imaginary numbers aren't understood
624 b:[2i]number // array sizes are handled separately
625 c:[3.14159]Boolean // array sizes must be integers
626 d:[1_000_000_000_000]number // they mustn't be huge
627 patn: string = "foo[ ,_]*bar"re // regexp strings are just a dream
630 This is a multiline string
631 With an unsupportable suffix
635 yy:[unknowable]number
637 zz:[zzsize]string // size must be constant, use ::=
639 // These numbers should be bad in all contexts: FIXME
642 ###### output: tokerr
643 .tmp.code:3:13: error: unsupported number suffix: 1i
644 .tmp.code:4:11: error: unsupported number suffix: 2i
645 .tmp.code:5:11: error: array size must be an integer: 3.14159
646 .tmp.code:6:11: error: array size is too large: 1_000_000_000_000
647 .tmp.code:7:23: error: unsupported string suffix: "foo[ ,_]*bar"re
648 .tmp.code:9:17: error: unsupported string suffix: """
649 This is a multiline string
650 With an unsupportable suffix
652 .tmp.code:14:11: error: undefined type: unknown
653 .tmp.code:15:12: error: name undeclared: unknowable
654 .tmp.code:17:12: error: array size must be a constant: zzsize
655 .tmp.code:20:12: error: unrecognised number: 00123
657 ## Tests for type errors
659 Type error don't cause parsing to abort, so we can fit many in the
660 one test program. Some type errors are found during the parse, others
661 during type analysis which doesn't run if parsing failed. So we cannot
662 fit everything in one.
664 These programs were generated by looking for the
665 various places that `type_err()` are called.
668 oceani_failing_tests += type_err1 type_err2 type_err3 type_err4
670 ###### test: type_err1
673 print "hello" ++ 5, 5 ++ "hello"
678 if 3 * 4 and not True: print "Weird"
680 ###### output: type_err1
681 .tmp.code:3:25: error: expected string found number
682 .tmp.code:3:28: error: expected string found number
683 .tmp.code:6:8: error: Cannot assign to a constant: b
684 .tmp.code:5:8: info: name was defined as a constant here
685 .tmp.code:6:8: error: Cannot assign to a constant: b
686 .tmp.code:5:8: info: name was defined as a constant here
687 .tmp.code:8:11: error: Arithmetic returns number but Boolean expected
688 oceani: type error in program - not running.
690 ###### test: type_err2
700 ###### output: type_err2
701 .tmp.code:4:8: error: variable 'a' redeclared
702 .tmp.code:3:8: info: this is where 'a' was first declared
703 .tmp.code:5:8: error: variable 'a' redeclared
704 .tmp.code:3:8: info: this is where 'a' was first declared
705 .tmp.code:6:8: error: variable 'a' redeclared
706 .tmp.code:3:8: info: this is where 'a' was first declared
707 .tmp.code:7:8: error: variable 'a' redeclared
708 .tmp.code:3:8: info: this is where 'a' was first declared
709 .tmp.code:8:8: Variable declared with no type or value: c
711 ###### test: type_err3
720 c = "hello" ++ (True and False)
722 print 45 + ( "Hello" ++ "there")
732 case "Hello": print "Hello"
734 a1:[5]number; a2:[5]number; a3:[10]number; a4:[5]string
746 ###### output: type_err3
747 .tmp.code:8:12: error: expected number but variable 'c' is string
748 .tmp.code:7:8: info: this is where 'c' was set to string
749 .tmp.code:8:12: error: Arithmetic returns number but string expected
750 .tmp.code:7:8: info: variable 'c' was set as string here.
751 .tmp.code:9:24: error: Boolean operation found where string expected
752 .tmp.code:10:12: error: Comparison returns Boolean but string expected
753 .tmp.code:7:8: info: variable 'c' was set as string here.
754 .tmp.code:11:21: error: Concat returns string but number expected
755 .tmp.code:12:8: error: string cannot be indexed
756 .tmp.code:12:8: error: string cannot be indexed
757 .tmp.code:21:13: error: expected number found string
758 .tmp.code:17:16: error: expected number, found string
759 .tmp.code:24:8: error: cannot assign value of type [5]number
760 .tmp.code:25:13: error: expected [5]number but variable 'a3' is [10]number
761 .tmp.code:23:36: info: this is where 'a3' was set to [10]number
762 .tmp.code:25:8: error: cannot assign value of type [5]number
763 .tmp.code:26:13: error: expected [5]number but variable 'a4' is [5]string
764 .tmp.code:23:51: info: this is where 'a4' was set to [5]string
765 .tmp.code:26:8: error: cannot assign value of type [5]number
766 .tmp.code:27:16: error: expected number found string
767 .tmp.code:28:16: error: expected string found Boolean
768 .tmp.code:29:12: error: have number but need string
769 .tmp.code:7:8: info: variable 'c' was set as string here.
770 .tmp.code:32:8: error: variable used but not declared: foo
771 .tmp.code:32:8: error: field reference attempted on none, not a struct
772 .tmp.code:32:16: error: expected none found number
773 .tmp.code:33:14: error: field reference attempted on string, not a struct
774 oceani: type error in program - not running.
776 ###### test: type_err4
781 ###### output: type_err4
782 .tmp.code:3:14: error: variable used but not declared: b
783 .tmp.code:3:16: error: expected none found number
784 .tmp.code:3:14: info: variable 'b' was set as none here.
785 oceani: type error in program - not running.
788 oceani_failing_tests += type_err_const type_err_const1
790 ###### test: type_err_const
793 bar ::= "string" + 56
800 ###### output: type_err_const
801 .tmp.code:4:16: error: expected number found string
802 .tmp.code:6:8: error: name already declared: bar
803 .tmp.code:4:8: info: this is where 'bar' was first declared
804 .tmp.code:8:8: error: variable 'foo' redeclared
805 .tmp.code:3:8: info: this is where 'foo' was first declared
807 ###### test: type_err_const1
815 ###### output: type_err_const1
816 .tmp.code:3:12: Syntax error in constant: :
817 .tmp.code:4:12: Syntax error in constant: :
819 ## Test erroneous command line args
821 To improve coverage, we want to test correct handling of strange command
822 line arguments. These tests won't use code, so the exiting test types
823 won't work. So we need to be able to explicitly give the command line,
824 and the expected output, and have that tested and the coverage assessed.
825 Rather than having to spell out the whole command name, just give "cmd",
826 and discard that. Requiring but discarding the command make an empty
827 command list possible.
830 @for t in $(oceani_special_tests); do \
831 echo -n "Test $$t ... ";\
832 i="$$IFS"; IFS=,; set $$t; IFS="$$i"; shift ;\
833 ./md2c oceani-tests.mdc "output: $$t" | grep -v '^#' > .tmp.want; \
834 ./oceani $${1+"$$@"} > .tmp.have 2>&1 ;\
835 if ! cmp -s .tmp.want .tmp.have; then \
836 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
838 ./coverage_oceani $${1+"$$@"} > /dev/null 2>&1 ;\
842 oceani_special_tests += "cmd"
843 oceani_special_tests += "cmd,-zyx"
844 oceani_special_tests += "cmd,nofile"
845 oceani_special_tests += "cmd,/dev/null"
846 oceani_special_tests += "cmd,--section,toast:nothing,oceani-tests.mdc"
849 oceani: no input file given
851 ###### output: cmd,-zyx
852 ./oceani: invalid option -- 'z'
853 Usage: oceani --trace --print --noexec --brackets--section=SectionName prog.ocn
855 ###### output: cmd,nofile
856 oceani: cannot open nofile
858 ###### output: cmd,/dev/null
859 oceani: could not find any code in /dev/null
861 ###### output: cmd,--section,toast:nothing,oceani-tests.mdc
862 oceani: cannot find section toast:nothing